osgWidget::VncImage Class Referenceabstract

`#include <VncClient>`

Inheritance diagram for osgWidget::VncImage:

## Public Member Functions

| VncImage ()
virtual bool | connect (const std::string &hostname)=0
virtual void | close ()=0
Public Member Functions inherited from osg::Image
| Image ()
| Image (const Image &image, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual osg::Image * | asImage ()
virtual const osg::Image * | asImage () const
virtual const GLvoid * | getDataPointer () const
virtual unsigned int | getTotalDataSize () const
virtual int | compare (const Image &rhs) const
void | setFileName (const std::string &fileName)
const std::string & | getFileName () const
void | setWriteHint (WriteHint writeHint)
WriteHint | getWriteHint () const
void | setAllocationMode (AllocationMode mode)
AllocationMode | getAllocationMode () const
virtual void | allocateImage (int s, int t, int r, GLenum pixelFormat, GLenum type, int packing=1)
virtual void | setImage (int s, int t, int r, GLint internalTextureformat, GLenum pixelFormat, GLenum type, unsigned char *data, AllocationMode mode, int packing=1, int rowLength=0)
virtual void | readPixels (int x, int y, int width, int height, GLenum pixelFormat, GLenum type, int packing=1)
virtual void | readImageFromCurrentTexture (unsigned int contextID, bool copyMipMapsIfAvailable, GLenum type=GL_UNSIGNED_BYTE, unsigned int face=0)
void | swap (osg::Image &rhs)
void | scaleImage (int s, int t, int r)
virtual void | scaleImage (int s, int t, int r, GLenum newDataType)
virtual void | copySubImage (int s_offset, int t_offset, int r_offset, const osg::Image *source)
void | setOrigin (Origin origin)
Origin | getOrigin () const
int | s () const
int | t () const
int | r () const
void | setRowLength (int length)
int | getRowLength () const
void | setInternalTextureFormat (GLint internalFormat)
GLint | getInternalTextureFormat () const
void | setPixelFormat (GLenum pixelFormat)
GLenum | getPixelFormat () const
void | setDataType (GLenum dataType)
GLenum | getDataType () const
void | setPacking (unsigned int packing)
unsigned int | getPacking () const
bool | isCompressed () const
void | setPixelAspectRatio (float pixelAspectRatio)
float | getPixelAspectRatio () const
unsigned int | getPixelSizeInBits () const
unsigned int | getRowSizeInBytes () const
unsigned int | getRowStepInBytes () const
unsigned int | getImageSizeInBytes () const
unsigned int | getImageStepInBytes () const
unsigned int | getTotalSizeInBytes () const
unsigned int | getTotalSizeInBytesIncludingMipmaps () const
bool | valid () const
unsigned char * | data ()
const unsigned char * | data () const
unsigned char * | data (unsigned int column, unsigned int row=0, unsigned int image=0)
const unsigned char * | data (unsigned int column, unsigned int row=0, unsigned int image=0) const
bool | isDataContiguous () const
Vec4 | getColor (unsigned int s, unsigned t=0, unsigned r=0) const
Vec4 | getColor (const Vec2 &texcoord) const
Vec4 | getColor (const Vec3 &texcoord) const
void | setColor (const osg::Vec4 &color, unsigned int s, unsigned int t=0, unsigned int r=0)
void | setColor (const osg::Vec4 &color, const osg::Vec2 &texcoord)
void | setColor (const osg::Vec4 &color, const osg::Vec3 &texcoord)
void | flipHorizontal ()
void | flipVertical ()
void | flipDepth ()
void | ensureValidSizeForTexturing (GLint maxTextureSize)
bool | isMipmap () const
unsigned int | getNumMipmapLevels () const
void | setMipmapLevels (const MipmapDataType &mipmapDataVector)
const MipmapDataType & | getMipmapLevels () const
unsigned int | getMipmapOffset (unsigned int mipmapLevel) const
unsigned char * | getMipmapData (unsigned int mipmapLevel)
const unsigned char * | getMipmapData (unsigned int mipmapLevel) const
bool | supportsTextureSubloading () const
virtual bool | isImageTranslucent () const
void | setPixelBufferObject (PixelBufferObject *buffer)
PixelBufferObject * | getPixelBufferObject ()
const PixelBufferObject * | getPixelBufferObject () const
virtual bool | requiresUpdateCall () const
virtual void | update (NodeVisitor *)
virtual bool | sendFocusHint (bool)
virtual bool | sendPointerEvent (int, int, int)
virtual bool | sendKeyEvent (int, bool)
virtual void | setFrameLastRendered (const osg::FrameStamp *)
void | addDimensionsChangedCallback (DimensionsChangedCallback *cb)
void | removeDimensionsChangedCallback (DimensionsChangedCallback *cb)
Public Member Functions inherited from osg::BufferData
| BufferData ()
| BufferData (const BufferData &bd, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual osg::Array * | asArray ()
virtual const osg::Array * | asArray () const
virtual osg::PrimitiveSet * | asPrimitiveSet ()
virtual const osg::PrimitiveSet * | asPrimitiveSet () const
void | setBufferObject (BufferObject *bufferObject)
BufferObject * | getBufferObject ()
const BufferObject * | getBufferObject () const
void | setBufferIndex (unsigned int index)
unsigned int | getBufferIndex () const
GLBufferObject * | getGLBufferObject (unsigned int contextID) const
GLBufferObject * | getOrCreateGLBufferObject (unsigned int contextID) const
void | setModifiedCallback (ModifiedCallback *md)
ModifiedCallback * | getModifiedCallback ()
const ModifiedCallback * | getModifiedCallback () const
void | dirty ()
void | setModifiedCount (unsigned int value)
unsigned int | getModifiedCount () const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
void | releaseGLObjects (State *state=0) const
unsigned int | getNumClients () const
void | addClient (osg::Object *)
void | removeClient (osg::Object *)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~VncImage ()
Protected Member Functions inherited from osg::Image
virtual | ~Image ()
Image & | operator= (const Image &)
void | handleDimensionsChangedCallbacks ()
void | deallocateData ()
void | setData (unsigned char *data, AllocationMode allocationMode)
Protected Member Functions inherited from osg::BufferData
virtual | ~BufferData ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Image
enum | WriteHint { NO_PREFERENCE , STORE_INLINE , EXTERNAL_FILE }
enum | AllocationMode { NO_DELETE , USE_NEW_DELETE , USE_MALLOC_FREE }
enum | Origin { BOTTOM_LEFT , TOP_LEFT }
typedef std::vector< unsigned int > | MipmapDataType
typedef std::vector< osg::ref_ptr< DimensionsChangedCallback > > | DimensionsChangedCallbackVector
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Image
static bool | isPackedType (GLenum type)
static GLenum | computePixelFormat (GLenum pixelFormat)
static GLenum | computeFormatDataType (GLenum pixelFormat)
static osg::Vec3i | computeBlockFootprint (GLenum pixelFormat)
static unsigned int | computeBlockSize (GLenum pixelFormat, GLenum packing)
static unsigned int | computeNumComponents (GLenum pixelFormat)
static unsigned int | computePixelSizeInBits (GLenum pixelFormat, GLenum type)
static unsigned int | computeRowWidthInBytes (int width, GLenum pixelFormat, GLenum type, int packing)
static unsigned int | computeImageSizeInBytes (int width, int height, int depth, GLenum pixelFormat, GLenum type, int packing=1, int slice_packing=1, int image_packing=1)
static int | roudUpToMultiple (int s, int pack)
static int | computeNearestPowerOfTwo (int s, float bias=0.5f)
static int | computeNumberOfMipmapLevels (int s, int t=1, int r=1)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Image
std::string | _fileName
WriteHint | _writeHint
Origin | _origin
int | _s
int | _t
int | _r
int | _rowLength
GLint | _internalTextureFormat
GLenum | _pixelFormat
GLenum | _dataType
unsigned int | _packing
float | _pixelAspectRatio
AllocationMode | _allocationMode
unsigned char * | _data
MipmapDataType | _mipmapData
DimensionsChangedCallbackVector | _dimensionsChangedCallbacks
Protected Attributes inherited from osg::BufferData
unsigned int | _modifiedCount
unsigned int | _bufferIndex
osg::ref_ptr< BufferObject > | _bufferObject
osg::ref_ptr< ModifiedCallback > | _modifiedCallback
unsigned int | _numClients
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

Pure virtual base class for VncImage that is sublcassed by vnc plugin to provide the actual implementation.

## Constructor & Destructor Documentation

## VncImage()

osgWidget::VncImage::VncImage | ( |  | ) |

inline

## ~VncImage()

virtual osgWidget::VncImage::~VncImage | ( |  | ) |

inline protected virtual

## Member Function Documentation

## close()

virtual void osgWidget::VncImage::close | ( |  | ) |

pure virtual

## connect()

virtual bool osgWidget::VncImage::connect | ( | const std::string & | hostname | ) |

pure virtual

The documentation for this class was generated from the following file:

- VncClient